Lreg1 <- function(fac, X0, y) {
  mc <- function(x, f)   # 'mean correct'
    x - (unlist(lapply(split(x, f), mean)))[f]
  rc <- function(X, y)   # 'regression coef'
    solve(crossprod(X), crossprod(X, y))
  b2 <- rc(apply(X0, 2, mc, fac), mc(y, fac))
  b1 <- unlist(lapply(split(y - X0%*%b2, fac), mean))
  c(b1, b2)
}

Lreg2 <- function(fac, X, y) {
  ni <- tabulate(unclass(fac))
  p1 <- length(ni)
  p <- ncol(X)
  XX <- matrix(0, p1 + p, p1 + p)
  diag(XX) <- c(ni, rep(0, p))
  XX[p1 + (1:p), p1 + (1:p)] <- crossprod(X)
  XX[p1 + (1:p), 1:p1] <-
    t(XX[1:p1, p1 + (1:p)] <-
      matrix(apply(X, 2, function(x, f)
                   unlist(lapply(split(x, f), sum)), fac),
             p1, p))
  b <- c(unlist(lapply(split(y, fac), sum)), crossprod(X, y))
  drop(solve(XX, b))
}

N <- 17065
fac <- factor(sample(1:107, N, rep=T))
X0 <- matrix(rnorm(4*N),,4)
y <- (1:107)[fac] + X0 %*% rep(1, 4) + rnorm(N, 0, 0.25)

options(object.size=2e7) # allow 20M objects
options(contrasts=c("contr.treatment", "contr.poly"))
resources(v0 <- lm(y ~ fac + X0 - 1))

resources(v1 <- Lreg1(fac, X0, y))

resources(v2 <- Lreg2(fac, X0, y))

Lreg2 <- function(fac, X, y) {
  ni <- tabulate(unclass(fac))
  p1 <- length(ni)
  p <- ncol(X)
  XX <- matrix(0, p1 + p, p1 + p)
  diag(XX) <- c(ni, rep(0, p))
  XX[p1 + (1:p), p1 + (1:p)] <- crossprod(X)
  XX[p1 + (1:p), 1:p1] <-
    t(XX[1:p1, p1 + (1:p)] <-
      matrix(apply(X, 2, function(x, f)
                   unlist(lapply(split(x, f), sum)), fac),
             p1, p))
  b <- c(unlist(lapply(split(y, fac), sum)), crossprod(X, y))
  b <- drop(solve(XX, b))
  resid <- y - (b[fac] + X %*% b[p1 + (1:p)])
  sigma2 <- sum(resid^2)/(length(y) - p - p1)
  list(coef = b, resid = resid, var = sigma2*solve(XX))
}
